"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PI_OVER_180 = Math.PI / 180;
exports.version = '@@version';
exports.isBrowser = typeof window !== 'undefined' &&
    ({}.toString.call(window) === '[object Window]' ||
        {}.toString.call(window) === '[object global]');
exports.isUnminified = /comment/.test(function () {
}.toString());
exports.dblClickWindow = 400;
exports.getAngle = function (angle) {
    return exports._getGlobalKonva().angleDeg ? angle * PI_OVER_180 : angle;
};
var _detectIE = function (ua) {
    var msie = ua.indexOf('msie ');
    if (msie > 0) {
        return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
    }
    var trident = ua.indexOf('trident/');
    if (trident > 0) {
        var rv = ua.indexOf('rv:');
        return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
    }
    var edge = ua.indexOf('edge/');
    if (edge > 0) {
        return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
    }
    return false;
};
exports._parseUA = function (userAgent) {
    var ua = userAgent.toLowerCase(), match = /(chrome)[ /]([\w.]+)/.exec(ua) ||
        /(webkit)[ /]([\w.]+)/.exec(ua) ||
        /(opera)(?:.*version|)[ /]([\w.]+)/.exec(ua) ||
        /(msie) ([\w.]+)/.exec(ua) ||
        (ua.indexOf('compatible') < 0 &&
            /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua)) ||
        [], mobile = !!userAgent.match(/Android|BlackBerry|iPhone|iPad|iPod|Opera Mini|IEMobile/i), ieMobile = !!userAgent.match(/IEMobile/i);
    return {
        browser: match[1] || '',
        version: match[2] || '0',
        isIE: _detectIE(ua),
        mobile: mobile,
        ieMobile: ieMobile
    };
};
exports.glob = typeof global !== 'undefined'
    ? global
    : typeof window !== 'undefined'
        ? window
        : typeof WorkerGlobalScope !== 'undefined'
            ? self
            : {};
exports.UA = exports._parseUA((exports.glob.navigator && exports.glob.navigator.userAgent) || '');
exports.document = exports.glob.document;
exports._getGlobalKonva = function () {
    return exports.glob.Konva;
};
exports._NODES_REGISTRY = {};
var globalKonva = {};
exports._injectGlobal = function (Konva) {
    globalKonva = Konva;
    exports.glob.Konva = Konva;
    Object.assign(Konva, exports._NODES_REGISTRY);
};
exports._registerNode = function (NodeClass) {
    exports._NODES_REGISTRY[NodeClass.prototype.getClassName()] = NodeClass;
    globalKonva[NodeClass.prototype.getClassName()] = NodeClass;
};
